#!/bin/sh

mem=$((grep MemTotal /proc/meminfo || echo 524288)| sed 's/[^0-9]//g')

[ $mem -ge 32948992 ] && mem=32948992

max_disk=$(cat /sys/block/[hsv]d*/size | sort -n -r| head -1)
[ -n "$max_disk" ] || max_disk=0

srootsize=50000000
boot_size=2000000

# Don't use raids under virtualization
if lspci -n | grep -qE '(1013:00b8)|(80ee:beef)|(14ad:0405)|(1af4:100)' ; then
	server_methods='plain'
	mem=$[$mem/4]
	srootsize=$[$srootsize/2]
else
# Don't use RAIDs at all for automatic disk partitioning
	server_methods='plain'
fi

{
cat << _EOF_
(
(workstation
(title . "Setup for server")
  (action . trivial)
  (actiondata
_EOF_
if [ `arch` = 'e2k' ]; then
# see also https://bugzilla.altlinux.org/34600
cat << _EOF_
   ("/boot" (size . $boot_size ) (fsim . "Ext4") (methods plain))
_EOF_
fi
cat << _EOF_
   ("swap" (size . $(($mem*2))) (fsim . "SWAPFS") (methods $server_methods))
_EOF_
# if disk size is less them 120G then
# there is no separate /var partition
if [ "$max_disk" -le 251658240 ]; then
cat << _EOF_
   ("/" (size $srootsize . #t ) (fsim . "Ext4") (methods $server_methods))
   ))
_EOF_
else
cat << _EOF_
   ("/" (size . $srootsize ) (fsim . "Ext4") (methods $server_methods))
   ("/var" (size 4194304 . #t) (fsim . "Ext4") (methods $server_methods))))
_EOF_
fi
cat << _EOF_
)
_EOF_
} > /var/cache/alterator/vm-profile.scm
